package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/orus-io/yago"
)

const (
	// LogEntryID is the ID field name
	LogEntryID = "ID"
	// LogEntryIDColumnName is the ID field associated column name
	LogEntryIDColumnName = "id"
	// LogEntryEnvelopeID is the EnvelopeID field name
	LogEntryEnvelopeID = "EnvelopeID"
	// LogEntryEnvelopeIDColumnName is the EnvelopeID field associated column name
	LogEntryEnvelopeIDColumnName = "envelope_id"
	// LogEntryActorID is the ActorID field name
	LogEntryActorID = "ActorID"
	// LogEntryActorIDColumnName is the ActorID field associated column name
	LogEntryActorIDColumnName = "actor_id"
	// LogEntryProcessID is the ProcessID field name
	LogEntryProcessID = "ProcessID"
	// LogEntryProcessIDColumnName is the ProcessID field associated column name
	LogEntryProcessIDColumnName = "process_id"
	// LogEntryNodeID is the NodeID field name
	LogEntryNodeID = "NodeID"
	// LogEntryNodeIDColumnName is the NodeID field associated column name
	LogEntryNodeIDColumnName = "node_id"
	// LogEntryTime is the Time field name
	LogEntryTime = "Time"
	// LogEntryTimeColumnName is the Time field associated column name
	LogEntryTimeColumnName = "time"
	// LogEntryLevel is the Level field name
	LogEntryLevel = "Level"
	// LogEntryLevelColumnName is the Level field associated column name
	LogEntryLevelColumnName = "level"
	// LogEntryText is the Text field name
	LogEntryText = "Text"
	// LogEntryTextColumnName is the Text field associated column name
	LogEntryTextColumnName = "text"
)

const (
	// LogEntryTableName is the LogEntry associated table name
	LogEntryTableName = "log_entry"
)

var logEntryTable = qb.Table(
	LogEntryTableName,
	qb.Column(LogEntryIDColumnName, qb.BigInt()).PrimaryKey().AutoIncrement().NotNull(),
	qb.Column(LogEntryEnvelopeIDColumnName, qb.UUID()).Null(),
	qb.Column(LogEntryActorIDColumnName, qb.UUID()).Null(),
	qb.Column(LogEntryProcessIDColumnName, qb.UUID()).Null(),
	qb.Column(LogEntryNodeIDColumnName, qb.Varchar()).NotNull(),
	qb.Column(LogEntryTimeColumnName, qb.Timestamp()).NotNull(),
	qb.Column(LogEntryLevelColumnName, qb.Varchar()).NotNull(),
	qb.Column(LogEntryTextColumnName, qb.Text()).NotNull(),
	qb.ForeignKey(LogEntryEnvelopeIDColumnName).References(EnvelopeTableName, BaseIDColumnName),
	qb.ForeignKey(LogEntryActorIDColumnName).References(ActorTableName, BaseIDColumnName),
).Index(
	LogEntryEnvelopeIDColumnName,
	LogEntryActorIDColumnName,
).Index(
	LogEntryProcessIDColumnName,
	LogEntryLevelColumnName,
)

var logEntryType = reflect.TypeOf(LogEntry{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (LogEntry) StructType() reflect.Type {
	return logEntryType
}

// LogEntryModel provides direct access to helpers for LogEntry
// queries
type LogEntryModel struct {
	mapper     *LogEntryMapper
	ID         yago.ScalarField
	EnvelopeID yago.ScalarField
	ActorID    yago.ScalarField
	ProcessID  yago.ScalarField
	NodeID     yago.ScalarField
	Time       yago.ScalarField
	Level      yago.ScalarField
	Text       yago.ScalarField
}

// NewLogEntryModel returns a new LogEntryModel
func NewLogEntryModel(meta *yago.Metadata) LogEntryModel {
	mapper := NewLogEntryMapper()
	meta.AddMapper(mapper)
	return LogEntryModel{
		mapper:     mapper,
		ID:         yago.NewScalarField(mapper.Table().C(LogEntryIDColumnName)),
		EnvelopeID: yago.NewScalarField(mapper.Table().C(LogEntryEnvelopeIDColumnName)),
		ActorID:    yago.NewScalarField(mapper.Table().C(LogEntryActorIDColumnName)),
		ProcessID:  yago.NewScalarField(mapper.Table().C(LogEntryProcessIDColumnName)),
		NodeID:     yago.NewScalarField(mapper.Table().C(LogEntryNodeIDColumnName)),
		Time:       yago.NewScalarField(mapper.Table().C(LogEntryTimeColumnName)),
		Level:      yago.NewScalarField(mapper.Table().C(LogEntryLevelColumnName)),
		Text:       yago.NewScalarField(mapper.Table().C(LogEntryTextColumnName)),
	}
}

// GetMapper returns the associated LogEntryMapper instance
func (m LogEntryModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewLogEntryMapper initialize a NewLogEntryMapper
func NewLogEntryMapper() *LogEntryMapper {
	m := &LogEntryMapper{}
	return m
}

// LogEntryMapper is the LogEntry mapper
type LogEntryMapper struct{}

// GetMapper returns itself
func (mapper *LogEntryMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*LogEntryMapper) Name() string {
	return "model/LogEntry"
}

// Table returns the mapper table
func (*LogEntryMapper) Table() *qb.TableElem {
	return &logEntryTable
}

// StructType returns the reflect.Type of the mapped structure
func (LogEntryMapper) StructType() reflect.Type {
	return logEntryType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper LogEntryMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*LogEntry)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &LogEntry{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != 0 {
		m[LogEntryIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, LogEntryEnvelopeID) {
		m[LogEntryEnvelopeIDColumnName] = s.EnvelopeID
	}
	if allValues || yago.StringListContains(fields, LogEntryActorID) {
		m[LogEntryActorIDColumnName] = s.ActorID
	}
	if allValues || yago.StringListContains(fields, LogEntryProcessID) {
		m[LogEntryProcessIDColumnName] = s.ProcessID
	}
	if allValues || yago.StringListContains(fields, LogEntryNodeID) {
		m[LogEntryNodeIDColumnName] = s.NodeID
	}
	if allValues || yago.StringListContains(fields, LogEntryTime) {
		m[LogEntryTimeColumnName] = s.Time
	}
	if allValues || yago.StringListContains(fields, LogEntryLevel) {
		m[LogEntryLevelColumnName] = s.Level
	}
	if allValues || yago.StringListContains(fields, LogEntryText) {
		m[LogEntryTextColumnName] = s.Text
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper LogEntryMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		logEntryTable.C(LogEntryIDColumnName),
		logEntryTable.C(LogEntryEnvelopeIDColumnName),
		logEntryTable.C(LogEntryActorIDColumnName),
		logEntryTable.C(LogEntryProcessIDColumnName),
		logEntryTable.C(LogEntryNodeIDColumnName),
		logEntryTable.C(LogEntryTimeColumnName),
		logEntryTable.C(LogEntryLevelColumnName),
		logEntryTable.C(LogEntryTextColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper LogEntryMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*LogEntry)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &LogEntry{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper LogEntryMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*LogEntry)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &LogEntry{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	if err := rows.Scan(
		&s.ID,
		&s.EnvelopeID,
		&s.ActorID,
		&s.ProcessID,
		&s.NodeID,
		&s.Time,
		&s.Level,
		&s.Text,
	); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (LogEntryMapper) AutoIncrementPKey() bool {
	return true
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (LogEntryMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	s := instance.(*LogEntry)
	s.ID = value
}

// PKey returns the instance primary key values
func (mapper LogEntryMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*LogEntry)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper LogEntryMapper) PKeyClause(values []interface{}) qb.Clause {
	return logEntryTable.C(LogEntryIDColumnName).Eq(values[0])
}
