// Copyright 2019 Orus.io. All rights reserved.

package sql

import (
	"testing"

	"bitbucket.org/orus-io/xbus/storage"
	"bitbucket.org/orus-io/xbus/testutils"
	"bitbucket.org/orus-io/xbus/testutils/sqldb"
	storagetest "bitbucket.org/orus-io/xbus/testutils/storage"
)

func pipelineStorageFactory(tb testing.TB) (storage.PipelineStorage, func()) {
	testDB := sqldb.GetTestDB(tb)
	if testDB == nil {
		return nil, nil
	}
	m, db := testDB.GetModelDB(1)

	return NewPipelineStorage(m, db, testutils.GetTestLogger(tb)), func() {
		db.Close()
		testDB.Close()
	}
}

func TestPipelineStorage(t *testing.T) {
	storagetest.PipelineStorageTests(t, pipelineStorageFactory)
}
